# Třídící algoritmus heapsort
#
# Jan Kybic, 2016

def bubble_down(a,i,n):
   while 2*i+1 < n:
      j=2*i+1 # zjisti index menšího syna
      if j+1 < n and a[j] < a[j+1]:
        j+=1
      if a[i]<a[j]:
        a[i],a[j]=a[j],a[i]
      i=j


def heap_sort(a):
  """ Setřídí pole 'a' na místě """
  n=len(a)
  for i in range((n-1)//2,-1,-1):
     bubble_down(a,i,n)
  for i in range(n-1,0,-1): # od n-1 do 1
    a[0],a[i]=a[i],a[0]   
    bubble_down(a,0,i)
  return a

# ------------------------------------ test part ----------------------------------


def main():
  import random
  import merge_sort_experiments
  import quick_sort_experiments
  import sorting_experiments

  a=[random.randrange(100) for i in range(10)]
  print(a)
  heap_sort(a)
  print(a)

  sorting_experiments.test_sort(f=heap_sort)  

  sorting_experiments.time_sorting_algorithms(ns=[1000,3000,10000,30000,100000],
                                              algs=[merge_sort_experiments.merge_sort,
                                                    quick_sort_experiments.quick_sort,
                                                    heap_sort,
                                                    sorting_experiments.python_sort],
                                                    prefix="time_with_heapsort")

    
if __name__=="__main__":
   main()

